routes/web.php
<?php

use App\Http\Controllers\SectorController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/{id}', [UserController::class, 'show']);

Route::get('/', [SectorController::class, 'index']);

app/Models/Sector.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Sector extends Model
{
    use HasFactory;

    public function users()
    {
        return $this->belongsToMany('App\Models\User');
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class User extends Model
{
    use HasFactory;

    protected $fillable = ['name'];

    public function sectors()
    {
        return $this->belongsToMany('App\Models\Sector');
    }

    public function getSectorIdsAttribute()
    {
        $userSectorIds = [];

        foreach ($this->sectors as $sector) {
            $userSectorIds[] = $sector->id;
        }
        return $userSectorIds;
    }
}

app/Http/Controllers/API/SectorController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\Sector;

class SectorController extends Controller
{
    public function index()
    {
        return Sector::all();
    }
}

app/Http/Controllers/API/UserController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;

class UserController extends Controller
{
    public function index()
    {
        return User::with('sectors')->get();
    }

    public function show($id)
    {
        return User::with('sectors')->find($id);
    }

    public function store(Request $request)
    {
        $request->validate(['name' => 'required', 'sectors' => 'required']);

        $collection = collect($request->input('sectors'));

        $collection->transform(
            function ($item, $key) {
                return (int)$item;
            }
        );

        $user = User::create(['name' => $request->input('name')]);
        $sector = $user->sectors()->sync($collection->all());

        return $user;
    }

    public function update(Request $request, $id)
    {
        $user = User::findOrFail($id);
        $name = $request->input('name');

        $request->validate(['name' => 'required', 'sectors' => 'required']);

        $user->update(['name' => $name]);

        $collection = collect($request->input('sectors'));

        $collection->transform(
            function ($item, $key) {
                return (int)$item;
            }
        );

        $sector = $user->sectors()->sync($collection->all());

        return $user;
    }

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/SectorController.php
<?php

namespace App\Http\Controllers;

use App\Models\Sector;

class SectorController extends Controller
{
    public function index()
    {
        return view('user')->with('sectors', Sector::all());
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Models\Sector;
use App\Models\User;

class UserController extends Controller
{
    public function index()
    {
        return view('user')->with(['sectors' => Sector::all()]);
    }

    public function show($id)
    {
        $user = User::with('sectors')->findOrFail($id);
        return view('user')->with(['user' => $user, 'sectors' => Sector::all()]);
    }
}

resources/views/user.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Sectors</title>

    <link href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{{ asset('/css/app.css') }}"/>
</head>
<body class="antialiased">

<h3>Please enter your name and pick the Sectors you are currently involved in.</h3>

<br>

<form id="sectorForm">
    @csrf
    <label for="name">Name</label>
    <input name="name" id="name" type="text" @isset($user) value="{{$user->name}}" @endif>

    <br>
    <br>

    <label for="sectors">Sectors</label>
    <select name="sectors" id="sectors" multiple size="15">
        @foreach ($sectors as $sector)
            @if($sector->is_group_name === 1)
                <optgroup label="{{$sector->name}}" class="level-{{$sector->level}}"></optgroup>
            @else
                @isset($user)
                    @if(in_array($sector->id, $user->sector_ids))
                        <option value="{{$sector->id}}" id="{{$sector->id}}"
                                class="level-{{$sector->level}}" selected>{{$sector->name}}</option>
                    @else
                        <option value="{{$sector->id}}" id="{{$sector->id}}"
                                class="level-{{$sector->level}}">{{$sector->name}}</option>
                    @endif
                @else
                    <option value="{{$sector->id}}" id="{{$sector->id}}"
                            class="level-{{$sector->level}}">{{$sector->name}}</option>
                @endif
            @endif
        @endforeach
    </select>

    <br>
    <br>

    <label for="terms">Agree to terms</label>
    <input name="terms" id="terms" type="checkbox">

    <br>

    <div id="validationMessages"></div>

    <br>

    @isset($user)
        <input type="hidden" id="userId" value="{{$user->id}}">
    @endif

    <input type="submit" value="Save">
</form>
<script src="{{ asset('/js/app.js') }}" type="text/javascript"></script>

</body>
</html>